/**
 * Yonius 0.2.9.
 *
 * Copyright (c) 2008-2019 Hive Solutions Lda.
 *
 * This source code is licensed under the Apache 2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('node-fetch')) :
  typeof define === 'function' && define.amd ? define(['exports', 'node-fetch'], factory) :
  (global = global || self, factory(global.yonius = {}, global.fetch));
}(this, function (exports, fetch) { 'use strict';

  fetch = fetch && fetch.hasOwnProperty('default') ? fetch['default'] : fetch;

  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }

    if (info.done) {
      resolve(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }

  function _asyncToGenerator(fn) {
    return function () {
      var self = this,
          args = arguments;
      return new Promise(function (resolve, reject) {
        var gen = fn.apply(self, args);

        function _next(value) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
        }

        function _throw(err) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
        }

        _next(undefined);
      });
    };
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);

    if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);
      if (enumerableOnly) symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });
      keys.push.apply(keys, symbols);
    }

    return keys;
  }

  function _objectSpread2(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};

      if (i % 2) {
        ownKeys(source, true).forEach(function (key) {
          _defineProperty(target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys(source).forEach(function (key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }

    return target;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        writable: true,
        configurable: true
      }
    });
    if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };
    return _getPrototypeOf(o);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };

    return _setPrototypeOf(o, p);
  }

  function isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;

    try {
      Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }

  function _construct(Parent, args, Class) {
    if (isNativeReflectConstruct()) {
      _construct = Reflect.construct;
    } else {
      _construct = function _construct(Parent, args, Class) {
        var a = [null];
        a.push.apply(a, args);
        var Constructor = Function.bind.apply(Parent, a);
        var instance = new Constructor();
        if (Class) _setPrototypeOf(instance, Class.prototype);
        return instance;
      };
    }

    return _construct.apply(null, arguments);
  }

  function _isNativeFunction(fn) {
    return Function.toString.call(fn).indexOf("[native code]") !== -1;
  }

  function _wrapNativeSuper(Class) {
    var _cache = typeof Map === "function" ? new Map() : undefined;

    _wrapNativeSuper = function _wrapNativeSuper(Class) {
      if (Class === null || !_isNativeFunction(Class)) return Class;

      if (typeof Class !== "function") {
        throw new TypeError("Super expression must either be null or a function");
      }

      if (typeof _cache !== "undefined") {
        if (_cache.has(Class)) return _cache.get(Class);

        _cache.set(Class, Wrapper);
      }

      function Wrapper() {
        return _construct(Class, arguments, _getPrototypeOf(this).constructor);
      }

      Wrapper.prototype = Object.create(Class.prototype, {
        constructor: {
          value: Wrapper,
          enumerable: false,
          writable: true,
          configurable: true
        }
      });
      return _setPrototypeOf(Wrapper, Class);
    };

    return _wrapNativeSuper(Class);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return self;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (typeof call === "object" || typeof call === "function")) {
      return call;
    }

    return _assertThisInitialized(self);
  }

  function _superPropBase(object, property) {
    while (!Object.prototype.hasOwnProperty.call(object, property)) {
      object = _getPrototypeOf(object);
      if (object === null) break;
    }

    return object;
  }

  function _get(target, property, receiver) {
    if (typeof Reflect !== "undefined" && Reflect.get) {
      _get = Reflect.get;
    } else {
      _get = function _get(target, property, receiver) {
        var base = _superPropBase(target, property);

        if (!base) return;
        var desc = Object.getOwnPropertyDescriptor(base, property);

        if (desc.get) {
          return desc.get.call(receiver);
        }

        return desc.value;
      };
    }

    return _get(target, property, receiver || target);
  }

  function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
  }

  function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
  }

  function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) {
      for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

      return arr2;
    }
  }

  function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
  }

  function _iterableToArray(iter) {
    if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
  }

  function _iterableToArrayLimit(arr, i) {
    if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
      return;
    }

    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"] != null) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance");
  }

  function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance");
  }

  var Observable =
  /*#__PURE__*/
  function () {
    function Observable() {
      _classCallCheck(this, Observable);

      this.callbacks = {};
    }

    _createClass(Observable, [{
      key: "bind",
      value: function bind(event, callback) {
        var callbacks = this.callbacks[event] || [];
        callbacks.push(callback);
        this.callbacks[event] = callbacks;
        return callback;
      }
    }, {
      key: "unbind",
      value: function unbind(event, callback) {
        var callbacks = this.callbacks[event] || [];

        if (!callback) {
          delete this.callbacks[event];
          return;
        }

        var index = callbacks.indexOf(callback);

        if (index === -1) {
          return;
        }

        callbacks.splice(index, 1);
        this.callbacks[event] = callbacks;
      }
    }, {
      key: "trigger",
      value: function trigger(event) {
        var callbacks = this.callbacks[event] || [];
        var results = [];
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = callbacks[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var callback = _step.value;
            var result = callback.apply(this, Array.prototype.slice.call(arguments, 1));
            result !== undefined && result !== null && results.push(result);
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator["return"] != null) {
              _iterator["return"]();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }

        return Promise.all(results);
      }
    }]);

    return Observable;
  }();

  var verify = function verify(condition) {
    var message = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
    var code = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
    var exception = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
    var kwargs = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};
    if (condition) return;
    message = message || "Verification failed";
    var Exception = exception || Error;
    kwargs = Object.assign({}, kwargs);
    if (message !== null && message !== undefined) kwargs.message = message;
    if (code !== null && message !== undefined) kwargs.code = code;
    var throwable = new Exception(kwargs.message || undefined);
    throwable.kwargs = kwargs;
    throw throwable;
  };
  var verifyEqual = function verifyEqual(first, second) {
    var message = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
    var code = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
    var exception = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : null;
    var kwargs = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : {};
    message = message || "Expected ".concat(first, " got ").concat(second);
    return this.verify(first === second, message, code, exception, kwargs);
  };
  var verifyNotEqual = function verifyNotEqual(first, second) {
    var message = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
    var code = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
    var exception = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : null;
    var kwargs = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : {};
    message = message || "Expected ".concat(first, " not equal to ").concat(second);
    return this.verify(first !== second, message, code, exception, kwargs);
  };
  var verifyMany = function verifyMany(sequence) {
    var message = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
    var code = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
    var exception = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
    var kwargs = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};
    sequence.forEach(function (element) {
      verify(element, message, code, exception, kwargs);
    });
  };

  var global$1 = typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {};

  const promises = {};

  // Copyright Joyent, Inc. and other Node contributors.
  //
  // Permission is hereby granted, free of charge, to any person obtaining a
  // copy of this software and associated documentation files (the
  // "Software"), to deal in the Software without restriction, including
  // without limitation the rights to use, copy, modify, merge, publish,
  // distribute, sublicense, and/or sell copies of the Software, and to permit
  // persons to whom the Software is furnished to do so, subject to the
  // following conditions:
  //
  // The above copyright notice and this permission notice shall be included
  // in all copies or substantial portions of the Software.
  //
  // THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
  // OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
  // MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
  // NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
  // DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
  // OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
  // USE OR OTHER DEALINGS IN THE SOFTWARE.
  // resolves . and .. elements in a path array with directory names there
  // must be no slashes, empty elements, or device names (c:\) in the array
  // (so also no leading and trailing slashes - it does not distinguish
  // relative and absolute paths)
  function normalizeArray(parts, allowAboveRoot) {
    // if the path tries to go above the root, `up` ends up > 0
    var up = 0;

    for (var i = parts.length - 1; i >= 0; i--) {
      var last = parts[i];

      if (last === '.') {
        parts.splice(i, 1);
      } else if (last === '..') {
        parts.splice(i, 1);
        up++;
      } else if (up) {
        parts.splice(i, 1);
        up--;
      }
    } // if the path is allowed to go above the root, restore leading ..s


    if (allowAboveRoot) {
      for (; up--; up) {
        parts.unshift('..');
      }
    }

    return parts;
  } // Split a filename into [root, dir, basename, ext], unix version
  // 'root' is just a slash, or nothing.


  var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;

  var splitPath = function splitPath(filename) {
    return splitPathRe.exec(filename).slice(1);
  }; // path.resolve([from ...], to)
  // posix version


  function resolve() {
    var resolvedPath = '',
        resolvedAbsolute = false;

    for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
      var path = i >= 0 ? arguments[i] : '/'; // Skip empty and invalid entries

      if (typeof path !== 'string') {
        throw new TypeError('Arguments to path.resolve must be strings');
      } else if (!path) {
        continue;
      }

      resolvedPath = path + '/' + resolvedPath;
      resolvedAbsolute = path.charAt(0) === '/';
    } // At this point the path should be resolved to a full absolute path, but
    // handle relative paths to be safe (might happen when process.cwd() fails)
    // Normalize the path


    resolvedPath = normalizeArray(filter(resolvedPath.split('/'), function (p) {
      return !!p;
    }), !resolvedAbsolute).join('/');
    return (resolvedAbsolute ? '/' : '') + resolvedPath || '.';
  }
  // posix version

  function normalize(path) {
    var isPathAbsolute = isAbsolute(path),
        trailingSlash = substr(path, -1) === '/'; // Normalize the path

    path = normalizeArray(filter(path.split('/'), function (p) {
      return !!p;
    }), !isPathAbsolute).join('/');

    if (!path && !isPathAbsolute) {
      path = '.';
    }

    if (path && trailingSlash) {
      path += '/';
    }

    return (isPathAbsolute ? '/' : '') + path;
  }

  function isAbsolute(path) {
    return path.charAt(0) === '/';
  } // posix version

  function join() {
    var paths = Array.prototype.slice.call(arguments, 0);
    return normalize(filter(paths, function (p, index) {
      if (typeof p !== 'string') {
        throw new TypeError('Arguments to path.join must be strings');
      }

      return p;
    }).join('/'));
  } // path.relative(from, to)
  function dirname(path) {
    var result = splitPath(path),
        root = result[0],
        dir = result[1];

    if (!root && !dir) {
      // No dirname whatsoever
      return '.';
    }

    if (dir) {
      // It has a dirname, strip trailing slash
      dir = dir.substr(0, dir.length - 1);
    }

    return root + dir;
  }

  function filter(xs, f) {
    if (xs.filter) return xs.filter(f);
    var res = [];

    for (var i = 0; i < xs.length; i++) {
      if (f(xs[i], i, xs)) res.push(xs[i]);
    }

    return res;
  } // String.prototype.substr - negative index don't work in IE8


  var substr = 'ab'.substr(-1) === 'b' ? function (str, start, len) {
    return str.substr(start, len);
  } : function (str, start, len) {
    if (start < 0) start = str.length + start;
    return str.substr(start, len);
  };

  // based off https://github.com/defunctzombie/node-process/blob/master/browser.js

  function defaultSetTimout() {
    throw new Error('setTimeout has not been defined');
  }

  function defaultClearTimeout() {
    throw new Error('clearTimeout has not been defined');
  }

  var cachedSetTimeout = defaultSetTimout;
  var cachedClearTimeout = defaultClearTimeout;

  if (typeof global$1.setTimeout === 'function') {
    cachedSetTimeout = setTimeout;
  }

  if (typeof global$1.clearTimeout === 'function') {
    cachedClearTimeout = clearTimeout;
  }

  function runTimeout(fun) {
    if (cachedSetTimeout === setTimeout) {
      //normal enviroments in sane situations
      return setTimeout(fun, 0);
    } // if setTimeout wasn't available but was latter defined


    if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
      cachedSetTimeout = setTimeout;
      return setTimeout(fun, 0);
    }

    try {
      // when when somebody has screwed with setTimeout but no I.E. maddness
      return cachedSetTimeout(fun, 0);
    } catch (e) {
      try {
        // When we are in I.E. but the script has been evaled so I.E. doesn't trust the global object when called normally
        return cachedSetTimeout.call(null, fun, 0);
      } catch (e) {
        // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error
        return cachedSetTimeout.call(this, fun, 0);
      }
    }
  }

  function runClearTimeout(marker) {
    if (cachedClearTimeout === clearTimeout) {
      //normal enviroments in sane situations
      return clearTimeout(marker);
    } // if clearTimeout wasn't available but was latter defined


    if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
      cachedClearTimeout = clearTimeout;
      return clearTimeout(marker);
    }

    try {
      // when when somebody has screwed with setTimeout but no I.E. maddness
      return cachedClearTimeout(marker);
    } catch (e) {
      try {
        // When we are in I.E. but the script has been evaled so I.E. doesn't  trust the global object when called normally
        return cachedClearTimeout.call(null, marker);
      } catch (e) {
        // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error.
        // Some versions of I.E. have different rules for clearTimeout vs setTimeout
        return cachedClearTimeout.call(this, marker);
      }
    }
  }

  var queue = [];
  var draining = false;
  var currentQueue;
  var queueIndex = -1;

  function cleanUpNextTick() {
    if (!draining || !currentQueue) {
      return;
    }

    draining = false;

    if (currentQueue.length) {
      queue = currentQueue.concat(queue);
    } else {
      queueIndex = -1;
    }

    if (queue.length) {
      drainQueue();
    }
  }

  function drainQueue() {
    if (draining) {
      return;
    }

    var timeout = runTimeout(cleanUpNextTick);
    draining = true;
    var len = queue.length;

    while (len) {
      currentQueue = queue;
      queue = [];

      while (++queueIndex < len) {
        if (currentQueue) {
          currentQueue[queueIndex].run();
        }
      }

      queueIndex = -1;
      len = queue.length;
    }

    currentQueue = null;
    draining = false;
    runClearTimeout(timeout);
  }

  function nextTick(fun) {
    var args = new Array(arguments.length - 1);

    if (arguments.length > 1) {
      for (var i = 1; i < arguments.length; i++) {
        args[i - 1] = arguments[i];
      }
    }

    queue.push(new Item(fun, args));

    if (queue.length === 1 && !draining) {
      runTimeout(drainQueue);
    }
  } // v8 likes predictible objects

  function Item(fun, array) {
    this.fun = fun;
    this.array = array;
  }

  Item.prototype.run = function () {
    this.fun.apply(null, this.array);
  };

  var title = 'browser';
  var platform = 'browser';
  var browser = true;
  var env = {};
  var argv = [];
  var version = ''; // empty string to avoid regexp issues

  var versions = {};
  var release = {};
  var config = {};

  function noop() {}

  var on = noop;
  var addListener = noop;
  var once = noop;
  var off = noop;
  var removeListener = noop;
  var removeAllListeners = noop;
  var emit = noop;
  function binding(name) {
    throw new Error('process.binding is not supported');
  }
  function cwd() {
    return '/';
  }
  function chdir(dir) {
    throw new Error('process.chdir is not supported');
  }
  function umask() {
    return 0;
  } // from https://github.com/kumavis/browser-process-hrtime/blob/master/index.js

  var performance = global$1.performance || {};

  var performanceNow = performance.now || performance.mozNow || performance.msNow || performance.oNow || performance.webkitNow || function () {
    return new Date().getTime();
  }; // generate timestamp or delta
  // see http://nodejs.org/api/process.html#process_process_hrtime


  function hrtime(previousTimestamp) {
    var clocktime = performanceNow.call(performance) * 1e-3;
    var seconds = Math.floor(clocktime);
    var nanoseconds = Math.floor(clocktime % 1 * 1e9);

    if (previousTimestamp) {
      seconds = seconds - previousTimestamp[0];
      nanoseconds = nanoseconds - previousTimestamp[1];

      if (nanoseconds < 0) {
        seconds--;
        nanoseconds += 1e9;
      }
    }

    return [seconds, nanoseconds];
  }
  var startTime = new Date();
  function uptime() {
    var currentTime = new Date();
    var dif = currentTime - startTime;
    return dif / 1000;
  }
  var process = {
    nextTick: nextTick,
    title: title,
    browser: browser,
    env: env,
    argv: argv,
    version: version,
    versions: versions,
    on: on,
    addListener: addListener,
    once: once,
    off: off,
    removeListener: removeListener,
    removeAllListeners: removeAllListeners,
    emit: emit,
    binding: binding,
    cwd: cwd,
    chdir: chdir,
    umask: umask,
    hrtime: hrtime,
    platform: platform,
    release: release,
    config: config,
    uptime: uptime
  };

  var HOME_DIR = env[ "HOME"] || "/";
  var pathExists =
  /*#__PURE__*/
  function () {
    var _ref = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(path) {
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.prev = 0;
              _context.next = 3;
              return promises.access(path);

            case 3:
              _context.next = 8;
              break;

            case 5:
              _context.prev = 5;
              _context.t0 = _context["catch"](0);
              return _context.abrupt("return", false);

            case 8:
              return _context.abrupt("return", true);

            case 9:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[0, 5]]);
    }));

    return function pathExists(_x) {
      return _ref.apply(this, arguments);
    };
  }();
  var expandUser = function expandUser(path) {
    if (!path) return path;
    if (path === "~") return HOME_DIR;
    if (path.slice(0, 2) !== "~/") return path;
    return join(HOME_DIR, path.slice(2));
  };

  var FILE_NAME = "yonius.json";
  var HOME_FILE = "~/.home";
  var IMPORT_NAMES = ["$import", "$include", "$IMPORT", "$INCLUDE"];
  var CASTS = {
    "int": function int(v) {
      return typeof v === "number" ? v : parseInt(v);
    },
    "float": function float(v) {
      return typeof v === "number" ? v : parseFloat(v);
    },
    bool: function bool(v) {
      return typeof v === "boolean" ? v : ["1", "true", "True"].includes(v);
    },
    list: function list(v) {
      return Array.isArray(v) ? v : v.split(";");
    },
    tuple: function tuple(v) {
      return Array.isArray(v) ? v : v.split(";");
    }
  };
  global$1.CONFIGS = global$1.CONFIGS === undefined ? {} : global$1.CONFIGS;
  global$1.CONFIG_F = global$1.CONFIG_F === undefined ? [] : global$1.CONFIG_F;
  global$1.HOMES = global$1.HOMES === undefined ? [] : global$1.HOMES;
  global$1.LOADED = global$1.LOADED === undefined ? false : global$1.LOADED;
  var conf = function conf(name) {
    var fallback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : undefined;
    var cast = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
    var ctx = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
    var configs = ctx ? ctx.configs : global$1.CONFIGS;
    cast = _castR(cast);
    var value = configs[name] === undefined ? fallback : configs[name];
    if (cast && value !== undefined && value !== null) value = cast(value);
    return value;
  };
  var confP =
  /*#__PURE__*/
  function () {
    var _ref = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(name) {
      var fallback,
          cast,
          ctx,
          _args = arguments;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              fallback = _args.length > 1 && _args[1] !== undefined ? _args[1] : undefined;
              cast = _args.length > 2 && _args[2] !== undefined ? _args[2] : null;
              ctx = _args.length > 3 && _args[3] !== undefined ? _args[3] : null;
              _context.next = 5;
              return load();

            case 5:
              return _context.abrupt("return", conf(name, fallback, cast, ctx));

            case 6:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function confP(_x) {
      return _ref.apply(this, arguments);
    };
  }();
  var confS = function confS(name, value) {
    var ctx = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
    var configs = ctx ? ctx.configs : global$1.CONFIGS;
    configs[name] = value;
  };
  var load =
  /*#__PURE__*/
  function () {
    var _ref2 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee2() {
      var names,
          path,
          encoding,
          force,
          ctx,
          paths,
          homes,
          _iteratorNormalCompletion,
          _didIteratorError,
          _iteratorError,
          _iterator,
          _step,
          home,
          _iteratorNormalCompletion2,
          _didIteratorError2,
          _iteratorError2,
          _iterator2,
          _step2,
          _path,
          _iteratorNormalCompletion3,
          _didIteratorError3,
          _iteratorError3,
          _iterator3,
          _step3,
          name,
          _args2 = arguments;

      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              names = _args2.length > 0 && _args2[0] !== undefined ? _args2[0] : [FILE_NAME];
              path = _args2.length > 1 && _args2[1] !== undefined ? _args2[1] : null;
              encoding = _args2.length > 2 && _args2[2] !== undefined ? _args2[2] : "utf-8";
              force = _args2.length > 3 && _args2[3] !== undefined ? _args2[3] : false;
              ctx = _args2.length > 4 && _args2[4] !== undefined ? _args2[4] : null;

              if (!(global$1.LOADED && !force)) {
                _context2.next = 7;
                break;
              }

              return _context2.abrupt("return");

            case 7:
              paths = [];
              _context2.next = 10;
              return getHomes();

            case 10:
              homes = _context2.sent;
              _iteratorNormalCompletion = true;
              _didIteratorError = false;
              _iteratorError = undefined;
              _context2.prev = 14;

              for (_iterator = homes[Symbol.iterator](); !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                home = _step.value;
                paths = paths.concat([join(home), join(home, ".config")]);
              }

              _context2.next = 22;
              break;

            case 18:
              _context2.prev = 18;
              _context2.t0 = _context2["catch"](14);
              _didIteratorError = true;
              _iteratorError = _context2.t0;

            case 22:
              _context2.prev = 22;
              _context2.prev = 23;

              if (!_iteratorNormalCompletion && _iterator["return"] != null) {
                _iterator["return"]();
              }

            case 25:
              _context2.prev = 25;

              if (!_didIteratorError) {
                _context2.next = 28;
                break;
              }

              throw _iteratorError;

            case 28:
              return _context2.finish(25);

            case 29:
              return _context2.finish(22);

            case 30:
              if (path) paths.push(path);
              _iteratorNormalCompletion2 = true;
              _didIteratorError2 = false;
              _iteratorError2 = undefined;
              _context2.prev = 34;
              _iterator2 = paths[Symbol.iterator]();

            case 36:
              if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
                _context2.next = 67;
                break;
              }

              _path = _step2.value;
              _iteratorNormalCompletion3 = true;
              _didIteratorError3 = false;
              _iteratorError3 = undefined;
              _context2.prev = 41;
              _iterator3 = names[Symbol.iterator]();

            case 43:
              if (_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done) {
                _context2.next = 50;
                break;
              }

              name = _step3.value;
              _context2.next = 47;
              return loadFile(name, _path, encoding, ctx);

            case 47:
              _iteratorNormalCompletion3 = true;
              _context2.next = 43;
              break;

            case 50:
              _context2.next = 56;
              break;

            case 52:
              _context2.prev = 52;
              _context2.t1 = _context2["catch"](41);
              _didIteratorError3 = true;
              _iteratorError3 = _context2.t1;

            case 56:
              _context2.prev = 56;
              _context2.prev = 57;

              if (!_iteratorNormalCompletion3 && _iterator3["return"] != null) {
                _iterator3["return"]();
              }

            case 59:
              _context2.prev = 59;

              if (!_didIteratorError3) {
                _context2.next = 62;
                break;
              }

              throw _iteratorError3;

            case 62:
              return _context2.finish(59);

            case 63:
              return _context2.finish(56);

            case 64:
              _iteratorNormalCompletion2 = true;
              _context2.next = 36;
              break;

            case 67:
              _context2.next = 73;
              break;

            case 69:
              _context2.prev = 69;
              _context2.t2 = _context2["catch"](34);
              _didIteratorError2 = true;
              _iteratorError2 = _context2.t2;

            case 73:
              _context2.prev = 73;
              _context2.prev = 74;

              if (!_iteratorNormalCompletion2 && _iterator2["return"] != null) {
                _iterator2["return"]();
              }

            case 76:
              _context2.prev = 76;

              if (!_didIteratorError2) {
                _context2.next = 79;
                break;
              }

              throw _iteratorError2;

            case 79:
              return _context2.finish(76);

            case 80:
              return _context2.finish(73);

            case 81:
              _context2.next = 83;
              return loadEnv(ctx);

            case 83:
              global$1.LOADED = true;

            case 84:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, null, [[14, 18, 22, 30], [23,, 25, 29], [34, 69, 73, 81], [41, 52, 56, 64], [57,, 59, 63], [74,, 76, 80]]);
    }));

    return function load() {
      return _ref2.apply(this, arguments);
    };
  }();
  var loadFile =
  /*#__PURE__*/
  function () {
    var _ref3 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee3() {
      var name,
          path,
          encoding,
          ctx,
          configs,
          configF,
          key,
          value,
          exists,
          filePath,
          basePath,
          data,
          dataJ,
          _i,
          _Object$entries,
          _Object$entries$_i,
          _args3 = arguments;

      return regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              name = _args3.length > 0 && _args3[0] !== undefined ? _args3[0] : FILE_NAME;
              path = _args3.length > 1 && _args3[1] !== undefined ? _args3[1] : null;
              encoding = _args3.length > 2 && _args3[2] !== undefined ? _args3[2] : "utf-8";
              ctx = _args3.length > 3 && _args3[3] !== undefined ? _args3[3] : null;
              configs = ctx ? ctx.configs : global$1.CONFIGS;
              configF = ctx ? ctx.configF : global$1.CONFIG_F;
              if (path) path = normalize(path);
              if (path) filePath = join(path, name);else filePath = name;
              filePath = resolve(filePath);
              filePath = normalize(filePath);
              basePath = dirname(filePath);
              _context3.next = 13;
              return pathExists(filePath);

            case 13:
              exists = _context3.sent;

              if (exists) {
                _context3.next = 16;
                break;
              }

              return _context3.abrupt("return");

            case 16:
              exists = configF.includes(filePath);
              if (exists) configF.splice(configF.indexOf(filePath), 1);
              configF.push(filePath);
              _context3.next = 21;
              return promises.readFile(filePath, {
                encoding: encoding
              });

            case 21:
              data = _context3.sent;
              dataJ = JSON.parse(data);
              _context3.next = 25;
              return _loadIncludes(basePath, dataJ, encoding);

            case 25:
              _i = 0, _Object$entries = Object.entries(dataJ);

            case 26:
              if (!(_i < _Object$entries.length)) {
                _context3.next = 36;
                break;
              }

              _Object$entries$_i = _slicedToArray(_Object$entries[_i], 2);
              key = _Object$entries$_i[0];
              value = _Object$entries$_i[1];

              if (_isValid(key)) {
                _context3.next = 32;
                break;
              }

              return _context3.abrupt("continue", 33);

            case 32:
              configs[key] = value;

            case 33:
              _i++;
              _context3.next = 26;
              break;

            case 36:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));

    return function loadFile() {
      return _ref3.apply(this, arguments);
    };
  }();
  var loadEnv =
  /*#__PURE__*/
  function () {
    var _ref4 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee4() {
      var ctx,
          configs,
          _args4 = arguments;
      return regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              ctx = _args4.length > 0 && _args4[0] !== undefined ? _args4[0] : null;
              configs = ctx ? ctx.configs : global$1.CONFIGS;

              if (!(env === undefined || env === null)) {
                _context4.next = 4;
                break;
              }

              return _context4.abrupt("return");

            case 4:
              Object.entries(env).forEach(function (_ref5) {
                var _ref6 = _slicedToArray(_ref5, 2),
                    key = _ref6[0],
                    value = _ref6[1];

                configs[key] = value;
              });

            case 5:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    }));

    return function loadEnv() {
      return _ref4.apply(this, arguments);
    };
  }();
  var getHomes =
  /*#__PURE__*/
  function () {
    var _ref7 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee5() {
      var filePath,
          fallback,
          encoding,
          forceDefault,
          exists,
          data,
          paths,
          _iteratorNormalCompletion4,
          _didIteratorError4,
          _iteratorError4,
          _iterator4,
          _step4,
          path,
          _args5 = arguments;

      return regeneratorRuntime.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              filePath = _args5.length > 0 && _args5[0] !== undefined ? _args5[0] : HOME_FILE;
              fallback = _args5.length > 1 && _args5[1] !== undefined ? _args5[1] : "~";
              encoding = _args5.length > 2 && _args5[2] !== undefined ? _args5[2] : "utf-8";
              forceDefault = _args5.length > 3 && _args5[3] !== undefined ? _args5[3] : false;

              if (!(global$1.HOMES.length > 0)) {
                _context5.next = 6;
                break;
              }

              return _context5.abrupt("return", global$1.HOMES);

            case 6:
              global$1.HOMES = env.HOMES === undefined ? null : env.HOMES;
              global$1.HOMES = global$1.HOMES ? global$1.HOMES.split(";") : global$1.HOMES;

              if (!(global$1.HOMES !== null)) {
                _context5.next = 10;
                break;
              }

              return _context5.abrupt("return", global$1.HOMES);

            case 10:
              fallback = expandUser(fallback);
              fallback = normalize(fallback);
              global$1.HOMES = [fallback];
              filePath = expandUser(filePath);
              filePath = normalize(filePath);
              _context5.next = 17;
              return pathExists(filePath);

            case 17:
              exists = _context5.sent;

              if (exists) {
                _context5.next = 20;
                break;
              }

              return _context5.abrupt("return", global$1.HOMES);

            case 20:
              if (!forceDefault) global$1.HOMES.splice(0, global$1.HOMES.length);
              _context5.next = 23;
              return promises.readFile(filePath, {
                encoding: encoding
              });

            case 23:
              data = _context5.sent;
              data = data.trim();
              paths = data.split(/\r?\n/);
              paths = paths.map(function (v) {
                return v.trim();
              });
              _iteratorNormalCompletion4 = true;
              _didIteratorError4 = false;
              _iteratorError4 = undefined;
              _context5.prev = 30;
              _iterator4 = paths[Symbol.iterator]();

            case 32:
              if (_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done) {
                _context5.next = 43;
                break;
              }

              path = _step4.value;
              path = path.trim();

              if (path) {
                _context5.next = 37;
                break;
              }

              return _context5.abrupt("continue", 40);

            case 37:
              path = expandUser(path);
              path = normalize(path);
              global$1.HOMES.push(path);

            case 40:
              _iteratorNormalCompletion4 = true;
              _context5.next = 32;
              break;

            case 43:
              _context5.next = 49;
              break;

            case 45:
              _context5.prev = 45;
              _context5.t0 = _context5["catch"](30);
              _didIteratorError4 = true;
              _iteratorError4 = _context5.t0;

            case 49:
              _context5.prev = 49;
              _context5.prev = 50;

              if (!_iteratorNormalCompletion4 && _iterator4["return"] != null) {
                _iterator4["return"]();
              }

            case 52:
              _context5.prev = 52;

              if (!_didIteratorError4) {
                _context5.next = 55;
                break;
              }

              throw _iteratorError4;

            case 55:
              return _context5.finish(52);

            case 56:
              return _context5.finish(49);

            case 57:
              return _context5.abrupt("return", global$1.HOMES);

            case 58:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5, null, [[30, 45, 49, 57], [50,, 52, 56]]);
    }));

    return function getHomes() {
      return _ref7.apply(this, arguments);
    };
  }();
  var _castR = function _castR(cast) {
    return CASTS[cast] === undefined ? cast : CASTS[cast];
  };
  var _loadIncludes =
  /*#__PURE__*/
  function () {
    var _ref8 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee6(basePath, config) {
      var encoding,
          includes,
          _iteratorNormalCompletion5,
          _didIteratorError5,
          _iteratorError5,
          _iterator5,
          _step5,
          alias,
          _iteratorNormalCompletion6,
          _didIteratorError6,
          _iteratorError6,
          _iterator6,
          _step6,
          include,
          _args6 = arguments;

      return regeneratorRuntime.wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              encoding = _args6.length > 2 && _args6[2] !== undefined ? _args6[2] : "utf-8";
              includes = [];
              _iteratorNormalCompletion5 = true;
              _didIteratorError5 = false;
              _iteratorError5 = undefined;
              _context6.prev = 5;

              for (_iterator5 = IMPORT_NAMES[Symbol.iterator](); !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
                alias = _step5.value;
                includes = config[alias] === undefined ? includes : config[alias];
              }

              _context6.next = 13;
              break;

            case 9:
              _context6.prev = 9;
              _context6.t0 = _context6["catch"](5);
              _didIteratorError5 = true;
              _iteratorError5 = _context6.t0;

            case 13:
              _context6.prev = 13;
              _context6.prev = 14;

              if (!_iteratorNormalCompletion5 && _iterator5["return"] != null) {
                _iterator5["return"]();
              }

            case 16:
              _context6.prev = 16;

              if (!_didIteratorError5) {
                _context6.next = 19;
                break;
              }

              throw _iteratorError5;

            case 19:
              return _context6.finish(16);

            case 20:
              return _context6.finish(13);

            case 21:
              if (typeof includes === "string") {
                includes = includes.split(";");
              }

              _iteratorNormalCompletion6 = true;
              _didIteratorError6 = false;
              _iteratorError6 = undefined;
              _context6.prev = 25;
              _iterator6 = includes[Symbol.iterator]();

            case 27:
              if (_iteratorNormalCompletion6 = (_step6 = _iterator6.next()).done) {
                _context6.next = 34;
                break;
              }

              include = _step6.value;
              _context6.next = 31;
              return loadFile(include, basePath, encoding);

            case 31:
              _iteratorNormalCompletion6 = true;
              _context6.next = 27;
              break;

            case 34:
              _context6.next = 40;
              break;

            case 36:
              _context6.prev = 36;
              _context6.t1 = _context6["catch"](25);
              _didIteratorError6 = true;
              _iteratorError6 = _context6.t1;

            case 40:
              _context6.prev = 40;
              _context6.prev = 41;

              if (!_iteratorNormalCompletion6 && _iterator6["return"] != null) {
                _iterator6["return"]();
              }

            case 43:
              _context6.prev = 43;

              if (!_didIteratorError6) {
                _context6.next = 46;
                break;
              }

              throw _iteratorError6;

            case 46:
              return _context6.finish(43);

            case 47:
              return _context6.finish(40);

            case 48:
            case "end":
              return _context6.stop();
          }
        }
      }, _callee6, null, [[5, 9, 13, 21], [14,, 16, 20], [25, 36, 40, 48], [41,, 43, 47]]);
    }));

    return function _loadIncludes(_x2, _x3) {
      return _ref8.apply(this, arguments);
    };
  }();
  var _isValid = function _isValid(key) {
    if (IMPORT_NAMES.includes(key)) return false;
    return true;
  };
  var _isDevel = function _isDevel() {
    return ["DEBUG"].includes(conf("LEVEL", "INFO"));
  };
  var _isSecure = function _isSecure() {
    return conf("SECURE", true, "bool");
  };

  var MixinBuilder =
  /*#__PURE__*/
  function () {
    function MixinBuilder(superclass) {
      _classCallCheck(this, MixinBuilder);

      this.superclass = superclass;
    }

    _createClass(MixinBuilder, [{
      key: "with",
      value: function _with() {
        for (var _len = arguments.length, mixins = new Array(_len), _key = 0; _key < _len; _key++) {
          mixins[_key] = arguments[_key];
        }

        return mixins.reduce(function (c, mixin) {
          return mixin(c);
        }, this.superclass);
      }
    }]);

    return MixinBuilder;
  }();
  var mix = function mix(superclass) {
    return new MixinBuilder(superclass);
  };

  var urlEncode = function urlEncode(values) {
    // constructs the parts array that is going to
    // store the multiple and values
    var parts = []; // in case the provided value is not an array
    // then assumes it's an object and retrieve entries

    if (!Array.isArray(values)) {
      values = Object.entries(values);
    } // iterates over the complete set of pairs available
    // from the key value pairs to be able to encode them
    // properly, notice that the values themselves can be
    // sequences allowing multiple repetition of key


    values.forEach(function (_ref) {
      var _ref2 = _slicedToArray(_ref, 2),
          key = _ref2[0],
          value = _ref2[1];

      if (!Array.isArray(value)) {
        value = [value];
      }

      var keyEncoded = encodeURIComponent(key);
      value.forEach(function (_value) {
        if (_value === undefined || _value === null) {
          return;
        }

        var valueEncoded = encodeURIComponent(_value);
        parts.push("".concat(keyEncoded, "=").concat(valueEncoded));
      });
    }); // joins the complete set of parts with the and
    // separator and then returns the final string value

    return parts.join("&");
  };

  var API =
  /*#__PURE__*/
  function (_Observable) {
    _inherits(API, _Observable);

    function API() {
      var _this;

      var kwargs = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      _classCallCheck(this, API);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(API).call(this));
      _this.kwargs = kwargs;
      return _this;
    }

    _createClass(API, [{
      key: "build",
      value: function () {
        var _build = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee(method, url) {
          return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:

                case 1:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee);
        }));

        function build(_x, _x2) {
          return _build.apply(this, arguments);
        }

        return build;
      }()
    }, {
      key: "get",
      value: function () {
        var _get = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee2(url) {
          var options,
              params,
              headers,
              kwargs,
              handle,
              query,
              response,
              result,
              _args2 = arguments;
          return regeneratorRuntime.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  options = _args2.length > 1 && _args2[1] !== undefined ? _args2[1] : {};
                  params = options.params !== undefined ? options.params : {};
                  headers = options.headers !== undefined ? options.headers : {};
                  kwargs = options.kwargs !== undefined ? options.kwargs : {};
                  handle = options.handle !== undefined ? options.handle : true;
                  _context2.next = 7;
                  return this.build("GET", url, {
                    params: params,
                    headers: headers,
                    kwargs: kwargs
                  });

                case 7:
                  query = urlEncode(params || {});
                  if (query) url += url.includes("?") ? "&" + query : "?" + query;
                  _context2.next = 11;
                  return fetch(url, {
                    method: "GET",
                    headers: headers || {}
                  });

                case 11:
                  response = _context2.sent;

                  if (!handle) {
                    _context2.next = 18;
                    break;
                  }

                  _context2.next = 15;
                  return this._handleResponse(response);

                case 15:
                  _context2.t0 = _context2.sent;
                  _context2.next = 19;
                  break;

                case 18:
                  _context2.t0 = response;

                case 19:
                  result = _context2.t0;
                  return _context2.abrupt("return", result);

                case 21:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2, this);
        }));

        function get(_x3) {
          return _get.apply(this, arguments);
        }

        return get;
      }()
    }, {
      key: "post",
      value: function () {
        var _post = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee3(url) {
          var options,
              params,
              headers,
              data,
              dataJ,
              dataM,
              mime,
              kwargs,
              handle,
              query,
              response,
              result,
              _args3 = arguments;
          return regeneratorRuntime.wrap(function _callee3$(_context3) {
            while (1) {
              switch (_context3.prev = _context3.next) {
                case 0:
                  options = _args3.length > 1 && _args3[1] !== undefined ? _args3[1] : {};
                  params = options.params !== undefined ? options.params : {};
                  headers = options.headers !== undefined ? options.headers : {};
                  data = options.data !== undefined ? options.data : null;
                  dataJ = options.dataJ !== undefined ? options.dataJ : null;
                  dataM = options.dataM !== undefined ? options.dataM : null;
                  mime = options.mime !== undefined ? options.mime : null;
                  kwargs = options.kwargs !== undefined ? options.kwargs : {};
                  handle = options.handle !== undefined ? options.handle : true;
                  _context3.next = 11;
                  return this.build("POST", url, {
                    params: params,
                    headers: headers,
                    data: data,
                    dataJ: dataJ,
                    dataM: dataM,
                    mime: mime,
                    kwargs: kwargs
                  });

                case 11:
                  query = urlEncode(params || {});

                  if (data !== null) {
                    if (query) url += url.includes("?") ? "&" + query : "?" + query;
                  } else if (dataJ !== null) {
                    data = JSON.stringify(dataJ);
                    if (query) url += url.includes("?") ? "&" + query : "?" + query;
                    mime = mime || "application/json";
                  } else if (dataM !== null) {
                    if (query) url += url.includes("?") ? "&" + query : "?" + query;
                  } else if (query) {
                    data = query;
                    mime = mime || "application/x-www-form-urlencoded";
                  }

                  headers = Object.assign({}, headers);
                  if (mime) headers["Content-Type"] = mime;
                  _context3.next = 17;
                  return fetch(url, {
                    method: "POST",
                    headers: headers || {},
                    body: data
                  });

                case 17:
                  response = _context3.sent;

                  if (!handle) {
                    _context3.next = 24;
                    break;
                  }

                  _context3.next = 21;
                  return this._handleResponse(response);

                case 21:
                  _context3.t0 = _context3.sent;
                  _context3.next = 25;
                  break;

                case 24:
                  _context3.t0 = response;

                case 25:
                  result = _context3.t0;
                  return _context3.abrupt("return", result);

                case 27:
                case "end":
                  return _context3.stop();
              }
            }
          }, _callee3, this);
        }));

        function post(_x4) {
          return _post.apply(this, arguments);
        }

        return post;
      }()
    }, {
      key: "_handleResponse",
      value: function () {
        var _handleResponse2 = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee4(response) {
          var result;
          return regeneratorRuntime.wrap(function _callee4$(_context4) {
            while (1) {
              switch (_context4.prev = _context4.next) {
                case 0:
                  result = null;

                  if (!(response.headers.get("content-type").toLowerCase() === "application/json")) {
                    _context4.next = 7;
                    break;
                  }

                  _context4.next = 4;
                  return response.json();

                case 4:
                  result = _context4.sent;
                  _context4.next = 10;
                  break;

                case 7:
                  _context4.next = 9;
                  return response.blob();

                case 9:
                  result = _context4.sent;

                case 10:
                  return _context4.abrupt("return", result);

                case 11:
                case "end":
                  return _context4.stop();
              }
            }
          }, _callee4);
        }));

        function _handleResponse(_x5) {
          return _handleResponse2.apply(this, arguments);
        }

        return _handleResponse;
      }()
    }]);

    return API;
  }(Observable);

  var OAuthAPI =
  /*#__PURE__*/
  function (_API) {
    _inherits(OAuthAPI, _API);

    function OAuthAPI() {
      _classCallCheck(this, OAuthAPI);

      return _possibleConstructorReturn(this, _getPrototypeOf(OAuthAPI).apply(this, arguments));
    }

    return OAuthAPI;
  }(API);

  var OAuth1API =
  /*#__PURE__*/
  function (_OAuthAPI) {
    _inherits(OAuth1API, _OAuthAPI);

    function OAuth1API() {
      _classCallCheck(this, OAuth1API);

      return _possibleConstructorReturn(this, _getPrototypeOf(OAuth1API).apply(this, arguments));
    }

    return OAuth1API;
  }(OAuthAPI);

  var OAuth2API =
  /*#__PURE__*/
  function (_OAuthAPI) {
    _inherits(OAuth2API, _OAuthAPI);

    function OAuth2API() {
      var _this;

      var kwargs = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      _classCallCheck(this, OAuth2API);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(OAuth2API).call(this, kwargs));
      _this.accessToken = null;
      return _this;
    }

    _createClass(OAuth2API, [{
      key: "build",
      value: function () {
        var _build = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee(method, url) {
          var options,
              params,
              headers,
              kwargs,
              token,
              _args = arguments;
          return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  options = _args.length > 2 && _args[2] !== undefined ? _args[2] : {};
                  _context.next = 3;
                  return _get(_getPrototypeOf(OAuth2API.prototype), "build", this).call(this, method, url, options);

                case 3:
                  params = options.params !== undefined ? options.params : {};
                  headers = options.headers !== undefined ? options.headers : {};
                  kwargs = options.kwargs !== undefined ? options.kwargs : {};
                  token = kwargs.token === undefined ? this.tokenDefault : kwargs.token;
                  delete kwargs.token;

                  if (token && this.oauthTypes.includes("param")) {
                    params[this.oauthParam] = this.getAccessToken();
                  }

                  if (token && this.oauthTypes.includes("header")) {
                    headers.Authorization = "Bearer ".concat(this.getAccessToken());
                  }

                case 10:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this);
        }));

        function build(_x, _x2) {
          return _build.apply(this, arguments);
        }

        return build;
      }()
    }, {
      key: "getAccessToken",
      value: function getAccessToken() {
        if (this.accessToken) return this.accessToken;
        throw new Error("No access token found must re-authorize");
      }
    }, {
      key: "oauthTypes",
      get: function get() {
        return ["param", "header"];
      }
    }, {
      key: "oauthParam",
      get: function get() {
        return "access_token";
      }
    }, {
      key: "tokenDefault",
      get: function get() {
        return true;
      }
    }]);

    return OAuth2API;
  }(OAuthAPI);

  var YoniusError =
  /*#__PURE__*/
  function (_Error) {
    _inherits(YoniusError, _Error);

    function YoniusError(message) {
      var _this;

      var code = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 500;

      _classCallCheck(this, YoniusError);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(YoniusError).call(this, message));
      _this.code = code;
      return _this;
    }

    _createClass(YoniusError, [{
      key: "isClient",
      get: function get() {
        return Math.floor(this.code / 100) === 4;
      }
    }, {
      key: "isServer",
      get: function get() {
        return Math.floor(this.code / 100) === 5;
      }
    }]);

    return YoniusError;
  }(_wrapNativeSuper(Error));
  var OperationalError =
  /*#__PURE__*/
  function (_YoniusError) {
    _inherits(OperationalError, _YoniusError);

    function OperationalError() {
      var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "Operational error";
      var code = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 500;

      _classCallCheck(this, OperationalError);

      return _possibleConstructorReturn(this, _getPrototypeOf(OperationalError).call(this, message, code));
    }

    return OperationalError;
  }(YoniusError);
  var NotFoundError =
  /*#__PURE__*/
  function (_OperationalError) {
    _inherits(NotFoundError, _OperationalError);

    function NotFoundError() {
      var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "Not found";
      var code = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 404;

      _classCallCheck(this, NotFoundError);

      return _possibleConstructorReturn(this, _getPrototypeOf(NotFoundError).call(this, message, code));
    }

    return NotFoundError;
  }(OperationalError);
  var NotImplementedError =
  /*#__PURE__*/
  function (_OperationalError2) {
    _inherits(NotImplementedError, _OperationalError2);

    function NotImplementedError() {
      var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "Not implemented";
      var code = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 501;

      _classCallCheck(this, NotImplementedError);

      return _possibleConstructorReturn(this, _getPrototypeOf(NotImplementedError).call(this, message, code));
    }

    return NotImplementedError;
  }(OperationalError);

  var REGISTRY = {};
  var load$1 =
  /*#__PURE__*/
  function () {
    var _ref = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee() {
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return load();

            case 2:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function load() {
      return _ref.apply(this, arguments);
    };
  }();
  var unload =
  /*#__PURE__*/
  function () {
    var _ref2 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee2() {
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    return function unload() {
      return _ref2.apply(this, arguments);
    };
  }();
  var register = function register(name, value) {
    REGISTRY[name] = value;
  };
  var unregister = function unregister(name) {
    delete REGISTRY[name];
  };
  var request = function request(name) {
    if (REGISTRY[name] === undefined) {
      throw new OperationalError("Name not found in registry");
    }

    return REGISTRY[name];
  };

  var Collection =
  /*#__PURE__*/
  function () {
    function Collection(options) {
      _classCallCheck(this, Collection);

      this.options = options;
    }

    _createClass(Collection, [{
      key: "find",
      value: function () {
        var _find = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee(conditions) {
          return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  throw new NotImplementedError();

                case 3:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee);
        }));

        function find(_x) {
          return _find.apply(this, arguments);
        }

        return find;
      }()
    }, {
      key: "findOne",
      value: function () {
        var _findOne = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee2(conditions) {
          return regeneratorRuntime.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  throw new NotImplementedError();

                case 3:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2);
        }));

        function findOne(_x2) {
          return _findOne.apply(this, arguments);
        }

        return findOne;
      }()
    }, {
      key: "findOneAndUpdate",
      value: function () {
        var _findOneAndUpdate = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee3(conditions, data) {
          return regeneratorRuntime.wrap(function _callee3$(_context3) {
            while (1) {
              switch (_context3.prev = _context3.next) {
                case 0:
                  throw new NotImplementedError();

                case 2:
                case "end":
                  return _context3.stop();
              }
            }
          }, _callee3);
        }));

        function findOneAndUpdate(_x3, _x4) {
          return _findOneAndUpdate.apply(this, arguments);
        }

        return findOneAndUpdate;
      }()
    }, {
      key: "findOneAndDelete",
      value: function () {
        var _findOneAndDelete = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee4(conditions) {
          return regeneratorRuntime.wrap(function _callee4$(_context4) {
            while (1) {
              switch (_context4.prev = _context4.next) {
                case 0:
                  throw new NotImplementedError();

                case 2:
                case "end":
                  return _context4.stop();
              }
            }
          }, _callee4);
        }));

        function findOneAndDelete(_x5) {
          return _findOneAndDelete.apply(this, arguments);
        }

        return findOneAndDelete;
      }()
    }]);

    return Collection;
  }();
  var MongoCollection =
  /*#__PURE__*/
  function (_Collection) {
    _inherits(MongoCollection, _Collection);

    function MongoCollection(name, schema) {
      var _this;

      _classCallCheck(this, MongoCollection);

      var mongoose = request("mongoose");
      _this = _possibleConstructorReturn(this, _getPrototypeOf(MongoCollection).call(this, name, schema));
      _this._mongoose = mongoose.model(_this.options.name, new mongoose.Schema(_this.options.schema));
      return _this;
    }

    _createClass(MongoCollection, [{
      key: "find",
      value: function () {
        var _find2 = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee5(conditions) {
          var projection,
              options,
              model,
              _args5 = arguments;
          return regeneratorRuntime.wrap(function _callee5$(_context5) {
            while (1) {
              switch (_context5.prev = _context5.next) {
                case 0:
                  projection = _args5.length > 1 && _args5[1] !== undefined ? _args5[1] : {};
                  options = _args5.length > 2 && _args5[2] !== undefined ? _args5[2] : {};
                  _context5.next = 4;
                  return this._mongoose.find(conditions, projection, options);

                case 4:
                  model = _context5.sent;
                  return _context5.abrupt("return", model);

                case 6:
                case "end":
                  return _context5.stop();
              }
            }
          }, _callee5, this);
        }));

        function find(_x6) {
          return _find2.apply(this, arguments);
        }

        return find;
      }()
    }, {
      key: "findOne",
      value: function () {
        var _findOne2 = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee6(conditions) {
          var projection,
              options,
              model,
              _args6 = arguments;
          return regeneratorRuntime.wrap(function _callee6$(_context6) {
            while (1) {
              switch (_context6.prev = _context6.next) {
                case 0:
                  projection = _args6.length > 1 && _args6[1] !== undefined ? _args6[1] : {};
                  options = _args6.length > 2 && _args6[2] !== undefined ? _args6[2] : {};
                  model = this._mongoose.findOne(conditions, projection, options);
                  return _context6.abrupt("return", model);

                case 4:
                case "end":
                  return _context6.stop();
              }
            }
          }, _callee6, this);
        }));

        function findOne(_x7) {
          return _findOne2.apply(this, arguments);
        }

        return findOne;
      }()
    }, {
      key: "findOneAndUpdate",
      value: function () {
        var _findOneAndUpdate2 = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee7(conditions, data) {
          var options,
              model,
              _args7 = arguments;
          return regeneratorRuntime.wrap(function _callee7$(_context7) {
            while (1) {
              switch (_context7.prev = _context7.next) {
                case 0:
                  options = _args7.length > 2 && _args7[2] !== undefined ? _args7[2] : {};
                  _context7.next = 3;
                  return this._mongoose.findOneAndUpdate(conditions, data, _objectSpread2({
                    upsert: true,
                    "new": true
                  }, options));

                case 3:
                  model = _context7.sent;
                  return _context7.abrupt("return", model);

                case 5:
                case "end":
                  return _context7.stop();
              }
            }
          }, _callee7, this);
        }));

        function findOneAndUpdate(_x8, _x9) {
          return _findOneAndUpdate2.apply(this, arguments);
        }

        return findOneAndUpdate;
      }()
    }, {
      key: "findOneAndDelete",
      value: function () {
        var _findOneAndDelete2 = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee8(conditions) {
          var options,
              model,
              _args8 = arguments;
          return regeneratorRuntime.wrap(function _callee8$(_context8) {
            while (1) {
              switch (_context8.prev = _context8.next) {
                case 0:
                  options = _args8.length > 1 && _args8[1] !== undefined ? _args8[1] : {};
                  _context8.next = 3;
                  return this._mongoose.findOneAndDelete(conditions, options);

                case 3:
                  model = _context8.sent;
                  return _context8.abrupt("return", model);

                case 5:
                case "end":
                  return _context8.stop();
              }
            }
          }, _callee8, this);
        }));

        function findOneAndDelete(_x10) {
          return _findOneAndDelete2.apply(this, arguments);
        }

        return findOneAndDelete;
      }()
    }]);

    return MongoCollection;
  }(Collection);

  var collection = /*#__PURE__*/Object.freeze({
    __proto__: null,
    Collection: Collection,
    MongoCollection: MongoCollection,
    'default': Collection
  });

  var MEMORY_STORAGE = {};
  var Model =
  /*#__PURE__*/
  function () {
    function Model() {
      _classCallCheck(this, Model);
    }

    _createClass(Model, [{
      key: "validate",
      value: function () {
        var _validate2 = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee() {
          var errors;
          return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  errors = _toConsumableArray(this._validate());

                  if (!errors.length) {
                    _context.next = 3;
                    break;
                  }

                  throw new Error("Invalid model: ".concat(errors.map(function (err) {
                    return String(err);
                  }).join(",")));

                case 3:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this);
        }));

        function validate() {
          return _validate2.apply(this, arguments);
        }

        return validate;
      }()
    }, {
      key: "wrap",
      value: function () {
        var _wrap2 = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee2(model) {
          return regeneratorRuntime.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  _context2.next = 2;
                  return this._wrap(model);

                case 2:
                  return _context2.abrupt("return", this);

                case 3:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2, this);
        }));

        function wrap(_x) {
          return _wrap2.apply(this, arguments);
        }

        return wrap;
      }()
    }, {
      key: "_wrap",
      value: function () {
        var _wrap3 = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee3(model) {
          return regeneratorRuntime.wrap(function _callee3$(_context3) {
            while (1) {
              switch (_context3.prev = _context3.next) {
                case 0:
                case "end":
                  return _context3.stop();
              }
            }
          }, _callee3);
        }));

        function _wrap(_x2) {
          return _wrap3.apply(this, arguments);
        }

        return _wrap;
      }()
    }, {
      key: "_validate",
      value:
      /*#__PURE__*/
      regeneratorRuntime.mark(function _validate() {
        return regeneratorRuntime.wrap(function _validate$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
              case "end":
                return _context4.stop();
            }
          }
        }, _validate);
      })
    }, {
      key: "model",
      get: function get() {
        throw new NotImplementedError();
      }
    }, {
      key: "jsonV",
      get: function get() {
        return this.model;
      }
    }, {
      key: "string",
      get: function get() {
        return JSON.stringify(this.model);
      }
    }], [{
      key: "adapter",
      get: function get() {
        return process.env.ADAPTER || "mongo";
      }
    }]);

    return Model;
  }();
  var ModelStore =
  /*#__PURE__*/
  function (_Model) {
    _inherits(ModelStore, _Model);

    function ModelStore() {
      _classCallCheck(this, ModelStore);

      return _possibleConstructorReturn(this, _getPrototypeOf(ModelStore).apply(this, arguments));
    }

    _createClass(ModelStore, [{
      key: "save",
      value: function () {
        var _save = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee4() {
          var validate,
              conditions,
              _args5 = arguments;
          return regeneratorRuntime.wrap(function _callee4$(_context5) {
            while (1) {
              switch (_context5.prev = _context5.next) {
                case 0:
                  validate = _args5.length > 0 && _args5[0] !== undefined ? _args5[0] : true;

                  if (!validate) {
                    _context5.next = 4;
                    break;
                  }

                  _context5.next = 4;
                  return this.validate();

                case 4:
                  conditions = {};
                  conditions[this.constructor.idName] = this.identifier;
                  _context5.next = 8;
                  return this.constructor.collection.findOneAndUpdate(conditions, this.model);

                case 8:
                  return _context5.abrupt("return", this);

                case 9:
                case "end":
                  return _context5.stop();
              }
            }
          }, _callee4, this);
        }));

        function save() {
          return _save.apply(this, arguments);
        }

        return save;
      }()
    }, {
      key: "delete",
      value: function () {
        var _delete2 = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee5() {
          var conditions;
          return regeneratorRuntime.wrap(function _callee5$(_context6) {
            while (1) {
              switch (_context6.prev = _context6.next) {
                case 0:
                  conditions = {};
                  conditions[this.constructor.idName] = this.identifier;
                  _context6.next = 4;
                  return this.constructor.collection.findOneAndDelete(conditions);

                case 4:
                  return _context6.abrupt("return", this);

                case 5:
                case "end":
                  return _context6.stop();
              }
            }
          }, _callee5, this);
        }));

        function _delete() {
          return _delete2.apply(this, arguments);
        }

        return _delete;
      }()
    }, {
      key: "identifier",
      get: function get() {
        return this[this.constructor.idName];
      }
    }], [{
      key: "find",
      value: function () {
        var _find = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee6() {
          var _this = this;

          var options,
              found,
              models,
              _args7 = arguments;
          return regeneratorRuntime.wrap(function _callee6$(_context7) {
            while (1) {
              switch (_context7.prev = _context7.next) {
                case 0:
                  options = _args7.length > 0 && _args7[0] !== undefined ? _args7[0] : {};
                  _context7.next = 3;
                  return this.collection.find(options);

                case 3:
                  found = _context7.sent;
                  _context7.next = 6;
                  return Promise.all(found.map(function (v) {
                    return new _this().wrap(v);
                  }));

                case 6:
                  models = _context7.sent;
                  return _context7.abrupt("return", models);

                case 8:
                case "end":
                  return _context7.stop();
              }
            }
          }, _callee6, this);
        }));

        function find() {
          return _find.apply(this, arguments);
        }

        return find;
      }()
    }, {
      key: "get",
      value: function () {
        var _get = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee7(id) {
          var options, model, instance;
          return regeneratorRuntime.wrap(function _callee7$(_context8) {
            while (1) {
              switch (_context8.prev = _context8.next) {
                case 0:
                  options = {};
                  options[this.idName] = id;
                  _context8.next = 4;
                  return this.collection.findOne(options);

                case 4:
                  model = _context8.sent;

                  if (model) {
                    _context8.next = 7;
                    break;
                  }

                  throw new NotFoundError();

                case 7:
                  instance = new this();
                  return _context8.abrupt("return", instance.wrap(model));

                case 9:
                case "end":
                  return _context8.stop();
              }
            }
          }, _callee7, this);
        }));

        function get(_x3) {
          return _get.apply(this, arguments);
        }

        return get;
      }()
    }, {
      key: "schema",
      get: function get() {
        throw new NotImplementedError();
      }
    }, {
      key: "collection",
      get: function get() {
        if (this._collection) return this._collection;
        var adapter = this.adapter[0].toUpperCase() + this.adapter.slice(1);
        this._collection = new collection[adapter + "Collection"](this.dataOptions);
        return this._collection;
      }
    }, {
      key: "idName",
      get: function get() {
        return "id";
      }
    }, {
      key: "dataOptions",
      get: function get() {
        return {
          name: this.name,
          schema: this.schema
        };
      }
    }]);

    return ModelStore;
  }(Model);
  var ModelMemory =
  /*#__PURE__*/
  function (_ModelStore) {
    _inherits(ModelMemory, _ModelStore);

    function ModelMemory() {
      _classCallCheck(this, ModelMemory);

      return _possibleConstructorReturn(this, _getPrototypeOf(ModelMemory).apply(this, arguments));
    }

    _createClass(ModelMemory, null, [{
      key: "adapter",
      get: function get() {
        return "memory";
      }
    }, {
      key: "dataOptions",
      get: function get() {
        return Object.assign(_get(_getPrototypeOf(ModelMemory), "dataOptions", this), {
          storage: this.storage
        });
      }
    }, {
      key: "storage",
      get: function get() {
        return MEMORY_STORAGE[this.name];
      }
    }]);

    return ModelMemory;
  }(ModelStore);

  exports.API = API;
  exports.Collection = Collection;
  exports.MixinBuilder = MixinBuilder;
  exports.Model = Model;
  exports.ModelMemory = ModelMemory;
  exports.ModelStore = ModelStore;
  exports.MongoCollection = MongoCollection;
  exports.NotFoundError = NotFoundError;
  exports.NotImplementedError = NotImplementedError;
  exports.OAuth1API = OAuth1API;
  exports.OAuth2API = OAuth2API;
  exports.OAuthAPI = OAuthAPI;
  exports.Observable = Observable;
  exports.OperationalError = OperationalError;
  exports.YoniusError = YoniusError;
  exports._castR = _castR;
  exports._isDevel = _isDevel;
  exports._isSecure = _isSecure;
  exports._isValid = _isValid;
  exports.conf = conf;
  exports.confP = confP;
  exports.confS = confS;
  exports.expandUser = expandUser;
  exports.load = load$1;
  exports.loadConf = load;
  exports.mix = mix;
  exports.pathExists = pathExists;
  exports.register = register;
  exports.request = request;
  exports.unload = unload;
  exports.unregister = unregister;
  exports.urlEncode = urlEncode;
  exports.verify = verify;
  exports.verifyEqual = verifyEqual;
  exports.verifyMany = verifyMany;
  exports.verifyNotEqual = verifyNotEqual;

  Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=yonius.umd.js.map
